preserve .
DEFINE TWOWAYSS (file = !CHAREND('/')
		/select = !CHAREND('/') !DEFAULT('ALL')
		/min = !CHAREND('/') !DEFAULT('-99')
		/max = !CHAREND('/') !DEFAULT('-99')
		/rnd = !CHAREND('/') !DEFAULT ('ON')
		/scree = !CHAREND('/') !DEFAULT ('NO')
		/ncomp = !CHAREND('/') !DEFAULT ('-99')
		/m = !CHAREND('/') !DEFAULT ('1')).

SET MXLOOPS = 1000000 .
!DO !I = !M !TO 1 !BY -1 .
GET FILE = !FILE .
matrix .
get  alles/file=*/names=varalles/ variables= all/ missing = -999 .
get  X/file=*/names=varnames/ variables= !select/ missing = -999 .

compute nmissing = (x ne -999) .
compute rndopt = {!INDEX(!rnd, OFF), !INDEX(!rnd, ON)} .
compute screeopt = {!INDEX(!scree, YES), !INDEX(!scree, NO)} .
compute rndln = !LENGTH(!rnd) .
compute screeln = !LENGTH(!scree) .
compute factor = (!ncomp = -99) .
do if not factor .
+  compute factor = (!ncomp > 0 and !ncomp < ncol(x)) .
end if.
compute minim = mmin(abs(x)) .
compute maxim = mmax(x) .
do if !min ne -99 .
+  compute minim = !min .
end if .
do if !max ne -99 .
+  compute maxim = !max .
end if .

do if mmax(x) > maxim or mmin(abs(x)) < minim . 
print /title '>Error: badly chosen minimum and/or maximum values (denoted by' .
print /title '>MIN and MAX). Make sure that the specified minimum is equal to or' .
print /title '>smaller than the smallest value of the selected variables and that the'. 
print /title '>specified maximum is equal to or greater than the greatest value'.
print /title '>of the selected variables. Missing values are not imputed in the new' .
print /title '>working file.'.

else if not all(rsum(x ne -999)) or not all(csum(x ne -999)) or not all(csum(x ne -999) - 1) or not all(csum(x ne -999) - 2).
print /title '>Error: missing values could not be imputed because some of the variables'.
print /title '>you selected may have almost no observed data, or some cases may have '.
print /title '>missing values on all of the variables you selected. Please choose different'.
print /title '>variables for the imputation procedure, or delete the cases or variables that '.
print /title '>have no observed data. '.

else if not any(rndopt) or (rndopt(:,1) and rndln > 3) or (rndopt(:,2) and rndln > 2) .
print /title '>Error: Invalid argument for specifying rnd. Valid arguments'.
print /title '>are OFF and ON. ON is default. Missing values are not imputed in the' .
print /title '>new working file. '. 

else if not any(screeopt) or (screeopt(:,1) and screeln > 3) or (screeopt(:,2) and screeln > 2) .
print /title '>Error: Invalid argument for specifying scree. Valid arguments'.
print /title '>are YES and NO. NO is default. Missing values are not imputed in the' .
print /title '>new working file. '. 

else if not factor .
print /title '>Error: Invalid number of factors. The number of factors must be greater'.
print /title '>than 0 and smaller than the total numer of variables used for imputation. '
print /title '>Missing values are not imputed in the new working file. ' .

else if all (nmissing) .
print /title '>Error: tw-ss cannot find any missing values. Are you sure you coded all missing'
print /title '>values into system-missing or user-missing?'


else.

************* Starting two-way imputation.
compute expected = make(nrow(x), ncol(x), 0) .
compute pmdenom = (rsum(nmissing)*make(1, ncol(x), 1)) - nmissing .
compute imdenom = (make(nrow(x), 1, 1)*csum(nmissing)) - nmissing .
compute omdenom = make(nrow(x), ncol(x), msum(nmissing)) - nmissing .
compute imsum = (make(nrow(x), 1,1)*csum(x&*nmissing) - x&*nmissing).
compute pmsum = (rsum(x&*nmissing)*make(1, ncol(x), 1) - x&*nmissing).
compute omsum = (make(nrow(x), ncol(x), msum(x&*nmissing)) - x&*nmissing).
loop i = 1 to nrow(x) .
+  loop j = 1 to ncol(x) .
+    do if imdenom(i,j) = 0 or pmdenom(i,j) = 0 or omdenom(i,j) = 0 .
+      compute expected(i,j) = -999 .
+     else .
+       compute expected(i,j) = pmsum(i,j)/pmdenom(i,j) + imsum(i,j)/imdenom(i,j) - omsum(i,j)/omdenom(i,j) .
+     end if .
+  end loop .
end loop .
compute xfull = expected&*(x = -999) + x&*nmissing.

***************Normally distributed error procedure.
compute dev = (x - expected)&*nmissing .
compute devsquar = (dev&**2)&*(expected ne -999) .
compute sderror = sqrt(msum(devsquar)/(msum(nmissing) - msum(expected = -999) - 1)) .
release dev, devsquar, expected, pmdenom, omdenom, imdenom, imsum, pmsum, omsum .
compute normaal = sderror*sqrt(-2*ln(uniform(nrow(x), ncol(x))))&*cos(2*3.1415926539*uniform(nrow(x), ncol(x)))  .
do if rndopt(:,1) .
+  compute xfull = xfull + (x = -999)&*normaal .
else .
+  compute xfull = rnd(xfull + (x = -999)&*normaal) .
end if .
release normaal .

do if not rndopt(:,1) .
+  loop i = 1 to nrow(x) .
+    loop j = 1 to ncol(x) .
+      do if xfull(i,j) > maxim .
+        compute xfull(i,j) = maxim .
+      else if xfull(i,j) < minim and xfull(i,j) ne -999 .
+        compute xfull(i,j) = minim .
+      end if .
+    end loop . /* end of loop j .
+  end loop . /*end of loop i .
end if .

****************Principal components analysis.
*correlation and covariance matrices .
compute mean = make(nrow(xfull),1,1)*csum(xfull)/nrow(xfull) - xfull .
compute covar = make(ncol(xfull), ncol(xfull), 0).
compute correlat = make(ncol(xfull), ncol(xfull), 0).
loop i = 1 to ncol(mean) .
+  loop j = 1 to ncol(mean) .
+    compute covar(i,j) = (t(mean(:,j))*mean(:,i))/(nrow(xfull)-1).
+  end loop.
end loop .
loop i = 1 to ncol(mean) .
+  loop j = 1 to ncol(mean) .
+    compute correlat(i,j) = covar(i,j)/sqrt(covar(i,i)*covar(j,j)) .
+  end loop.
end loop .

*singular value decomposition.
call svd(correlat,U,L,V).
*factor loadings.
compute lambda = V*sqrt(L).
do if !ncomp = -99 .
+  compute lambda = lambda(:,1:msum(L >= 1) ).
else .
+  compute lambda = lambda(:,1:!ncomp ).
end if.
loop j = 1 to ncol(lambda) .
+  do if csum(lambda(:,j)) < 0 .
+    compute lambda(:,j) = -lambda(:,j) .
+  end if .
end loop .
compute H = mdiag(rsum(lambda&**2)) .
compute lambda2 = sqrt(inv(H))*lambda.
*Varimax rotation.
compute SV1 = 0.
compute SV2 = 0.
loop g = 1 to 1000.
+  compute SV1 = SV2.
+  compute SV2 = 0.
+  loop i = 1 to ncol(lambda2) .
+    loop j = i+1 to ncol(lambda2) .
+      compute u = Lambda2(:,i)&**2 - Lambda2(:,j)&**2.
+      compute v = 2*Lambda2(:,i)&*Lambda2(:,j) .
+      compute A = msum(u) .
+      compute B = msum(v) .
+      compute C = msum(u&*u - v&*v) .
+      compute D = 2*msum(u&*v) .
+      compute E = D - (2*A*B)/ncol(xfull) .
+      do if abs(E) < 10E-10 .
+        compute E = 0.
+      end if.
+      compute F = C - (A**2-B**2)/ncol(xfull).
+      do if abs(F) < 10E-10 .
+         compute F = 0.
+      end if.
+      compute P = artan(E/F) .
+      do if F < 0 .
+        do if  E >= 0 .
+          compute P = P + 2*3.1415926539 .
+        end if .
+        compute P = P - 3.14159265439 .
+      end if.
+      compute P = P/4 .
+      compute Lambdaj = Lambda2(:,i).
+      compute Lambdak = Lambda2(:,j).
+      compute Lambda2(:,i) = Lambdaj*cos(P) + Lambdak*sin(P).
+      compute Lambda2(:,j) = Lambdaj*(-sin(P)) + Lambdak*cos(P).
+    end loop . 
+  end loop.
+  compute part1 = csum((Lambda2)&**4)*ncol(xfull) .
+  compute part2 = csum((Lambda2)&**2)&**2.
+  compute part3 = part1 - part2 .
+  compute SV2 = msum(part3).
+  do if (SV2 - SV1) < 10E-10 .
+    break .
+  end if .
end loop .
release lambda.
compute lambda = sqrt(H)*Lambda2 .
loop j = 1 to ncol(lambda) .
+  do if csum(lambda(:,j)) < 0 .
+    compute lambda(:,j) = -lambda(:,j) .
+  end if .
end loop .

****************Starting two-way for separate scales.
compute xfull = x.
compute midrange = make(nrow(x), ncol(x), (minim + maxim)/2 ).
compute maxlamb = make(nrow(lambda), ncol(lambda), 0) .
loop m = 1 to nrow(lambda) .
+  loop n = 1 to ncol(lambda) .
+    do if lambda(m,n) >= 0 .
+      compute maxlamb(m,n) = (abs(lambda(m,n)) = mmax(abs(lambda(m,:))) ).
+    else if lambda(m,n) < 0 .
+      compute maxlamb(m,n) = -(abs(lambda(m,n)) = mmax(abs(lambda(m,:))) ).
+    end if .
+  end loop .
end loop .
compute expected = make(nrow(x), ncol(x), 0) .
compute warn = 0 .
loop f = 1 to ncol(lambda) .
+  compute missvec = make(nrow(x), 1, 0) .
+  loop i = 1 to nrow(x) .
+    loop j = 1 to ncol(x) .
+      do if abs(maxlamb(j,f)) = 1 and abs(lambda(j,f)) >= 0.32 .
+        compute missvec(i) = missvec(i) + nmissing(i,j) .
+      end if.
+    end loop .
+  end loop .
+  compute lambmat= make(nrow(x), 1,1)*t(maxlamb(:,f)&*(abs(lambda(:,f)) >= 0.32))&*nmissing.
+  compute lambmat2= make(nrow(x), 1,1)*t(maxlamb(:,f))&*nmissing.
+  compute pmdenom =rsum(abs(lambmat))*make(1, ncol(x), 1) - abs(lambmat).
+  compute imdenom = make(nrow(x), 1, 1)*csum(abs(lambmat2)) - abs(lambmat2) .
+  compute omdenom = make(nrow(x), ncol(x), msum(abs(lambmat))) - abs(lambmat) .
+  compute imsum = make(nrow(x), 1,1)*csum((x-midrange)&*lambmat2) - (x-midrange)&*lambmat2.
+  compute pmsum = rsum((x-midrange)&*lambmat)*make(1, ncol(x), 1) - (x-midrange)&*lambmat.
+  compute omsum = make(nrow(x), ncol(x), msum((x-midrange)&*lambmat)) - (x-midrange)&*lambmat.
+  loop i = 1 to nrow(x) .
+    loop j = 1 to ncol(x) .
+      do if (abs(maxlamb(j,f)) = 1) .
+        do if ((missvec(i) > 0 and nmissing(i,j) = 0) or (missvec(i) > 1 and nmissing(i,j) = 1)) and (mmax(abs(lambda(j,:))) >= 0.32 ).
+          compute expected(i,j) = ((maxlamb(j,f)*pmsum(i,j))/pmdenom(i,j) + midrange(i,j)) + ((maxlamb(j,f)*imsum(i,j))/imdenom(i,j) + midrange(i,j)) - ((maxlamb(j,f)*omsum(i,j))/omdenom(i,j) + midrange(i,j)) .
+        else if (missvec(i) = 0) or (mmax(abs(lambda(j,:))) < 0.32 ).
+          compute expected(i,j) = ((maxlamb(j,f)*imsum(i,j))/imdenom(i,j) + midrange(i,j)) .
+          do if  (missvec(i) = 0) .
+            compute warn = 1 .
+          end if .
+        else if (missvec(i) = 1 and nmissing(i,j) = 1) .
+          compute expected(i,j) = -999.
+        end if.
+      end if .
+    end loop .
+  end loop .
end loop .
compute xfull = expected&*(x = -999) + x&*nmissing.

***************Normally distributed error procedure.
compute dev = (x - expected)&*nmissing .
compute imdenom = make(nrow(x), 1, 1)*csum(nmissing)) .
compute imdenom = imdenom - nmissing .
compute imsum = make(nrow(x), 1,1)*csum(x&*nmissing)) .
compute imsum = imsum - x&*nmissing .
compute expecte2 = imsum/imdenom .
compute dev2 = (x - expecte2)&*nmissing .
compute expmiss = (expected ne -999) .
compute devsquar = 0 .
compute devsqua2 = make(1, ncol(x), 0) .
compute sddenom = 0 .
compute normaal = make(nrow(x), ncol(x), 0) .
compute sderror = make(nrow(x), ncol(x), 0) .
compute devsqua2 = cssq(dev2) .
loop f = 1 to ncol(lambda) .
+  compute missvec = make(nrow(x), 1, 0) .
+  loop i = 1 to nrow(x) .
+    loop j = 1 to ncol(x) .
+      do if abs(maxlamb(j,f)) = 1 and abs(lambda(j,f)) >= 0.32 .
+        compute missvec(i) = missvec(i) + nmissing(i,j) .
+      end if.
+    end loop .
+  end loop .
+  loop i = 1 to nrow(x) .
+    loop j = 1 to ncol(x) .
+      do if (abs(maxlamb(j,f)) = 1) and (missvec(i) > 0) and (mmax(abs(lambda(j,:))) >= 0.32 ).
+        compute devsquar = devsquar + (dev(i,j)**2)*expmiss(i,j).
+        compute sddenom = sddenom + nmissing(i,j)*expmiss(i,j) .
+      end if .
+    end loop .
+  end loop .
+  loop i = 1 to nrow(x) .
+    loop j = 1 to ncol(x) .
+      do if (abs(maxlamb(j,f)) = 1) .
+        do if (missvec(i) > 0) and (mmax(abs(lambda(j,:))) >= 0.32 ).
+          compute sderror(i,j) = sqrt(devsquar/(sddenom-1)) .
+        else if (missvec(i) = 0) or (mmax(abs(lambda(j,:))) < 0.32 ).
+          compute sderror(i,j) = sqrt(devsqua2(j)/(csum(nmissing(:,j))-1)) .
+        end if .
+      end if .
+    end loop .
+  end loop .
end loop .

compute normaal = sderror&*sqrt(-2*ln(uniform(nrow(x), ncol(x))))&*cos(2*3.1415926539*uniform(nrow(x), ncol(x)))  .

do if rndopt(:,1) .
+  compute xfull = xfull + (x = -999)&*normaal .
else .
+  compute xfull = rnd(xfull + (x = -999)&*normaal) .
end if .
release dev, devsquar, expected, pmdenom, omdenom, imdenom, imsum, pmsum, omsum, normaal .

do if not rndopt(:,1) .
+  loop i = 1 to nrow(x) .
+    loop j = 1 to ncol(x) .
+      do if xfull(i,j) > maxim .
+        compute xfull(i,j) = maxim .
+      else if xfull(i,j) < minim and xfull(i,j) ne -999 .
+        compute xfull(i,j) = minim .
+      end if .
+    end loop . /* end of loop j .
+  end loop . /*end of loop i .
end if .

loop y = 1 to ncol(varalles) .
+  loop z = 1 to ncol(varnames) .
+    do if varalles(:,y) = varnames(:,z) .
+      compute alles(:,y) = xfull(:,z) .
+    end if .
+  end loop . /*end of loop z . 
end loop . /*end of loop y.

do if warn = 1 .
print /title ">Warning: for at least one case a complete subscale is missing."
print /title ">Imputations continue despite this warning, but for completely missing" 
print /title ">subscales only item means with error are imputed. It is strongly"
print /title ">recommended to inspect the incomplete data file for cases with many"
print /title ">missing values, and to delete these cases when considered necessary."
print .
end if .

!LET !len = !INDEX(!UNQUOTE(!FILE), '.sav')   .

!LET !FILENAME = !CONCAT(!SUBSTR(!FILE, 1, !len ), '_imp.sav', !SUBSTR(!FILE,1,1) ) .

!LET !FILENAME2 = !CONCAT(!SUBSTR(!FILE, 1, !len ), '_imp2.sav', !SUBSTR(!FILE,1,1) ) .

do if !I = 1 .
print /title "New data saved to file:"
print /title !FILENAME
print /title "Missing values that were not imputed are system-missing." .
end if .
end if .

do if screeopt(:,1) .
compute eig = {1:ncol(x);t(rsum(L))} .
compute eig = t(eig).
SAVE eig  
    /OUTFILE !CONCAT(!SUBSTR(!FILE, 1, !len ), '_eig', !I, '.sav', !SUBSTR(!FILE,1,1) ) .
end if .

SAVE alles  
    /OUTFILE !FILENAME2 
    /NAMES =varalles .

end matrix .
GET FILE =  !FILENAME2
APPLY DICTIONARY FROM !FILE
  /SOURCE VARIABLES = all
  /FILEINFO
  /VARINFO ALIGNMENT FORMATS LEVEL MISSING VALLABELS = REPLACE VARLABEL WIDTH .
RECODE all (-999=SYSMIS)  .
COMPUTE imputation_ = !I .
!IF (!I < !M) !THEN .
ADD FILES /FILE=*
 /FILE= !FILENAME
EXECUTE.
!IFEND .
SAVE OUTFILE=!FILENAME .
  /COMPRESSED.
!DOEND .
!IF (!scree = 'YES') !THEN .
!DO !I = 1 !TO !M .
GET FILE = !CONCAT(!SUBSTR(!FILE, 1, !len ), '_eig', !I, '.sav', !SUBSTR(!FILE,1,1) ) .
VARIABLE LABELS COL1 'Component Number' .
VARIABLE LABELS COL2 'Eigenvalue' .
IGRAPH /VIEWNAME='Line Chart' /X1 = VAR(COL1) TYPE = SCALE /Y = VAR(COL2) TYPE = SCALE /COORDINATE = VERTICAL
 /TITLE='Screeplot' /X1LENGTH=4.0 /YLENGTH=4.0 /X2LENGTH=4.0 /CHARTLOOK='NONE' /LINE(MEAN) KEY=ON STYLE = DOTLINE DROPLINE =
  ON INTERPOLATE = STRAIGHT BREAK = MISSING.
EXE.
!DOEND.
!IFEND .
GET FILE = !FILENAME .
!IF (!scree = 'YES') !THEN .
!DO !I = 1 !TO !M .
ERASE FILE = !CONCAT(!SUBSTR(!FILE, 1, !len ), '_eig', !I, '.sav', !SUBSTR(!FILE,1,1) ) .
!DOEND .
!IFEND .
GET FILE = !FILE .
COMPUTE imputation_ = 0 .
EXECUTE .
VALUE LABELS imputation_ 0 'Original'. 
ADD FILES /FILE=*
 /FILE= !FILENAME
EXECUTE.
FORMAT imputation_ (F1.0) .
SAVE OUTFILE= !FILENAME
  /COMPRESSED.
ERASE FILE !FILENAME2 .
!ENDDEFINE .
restore .